/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : FuzzySet.cc                                               */
/*************************************************************************/
/*************************************************************************/

#include <stdio.h>
#include <iostream.h>
#include "FuzzySet.h"
#include "Vector.h"
#include "MembershipFunction.h"
#include "MembershipVector.h"

FuzzySet::FuzzySet()
{  myMF = NULL;
   myValues = new Vector(1);
   index = 0;
}// end of constructor

FuzzySet::FuzzySet(MembershipFunction *_myMF)
{  myMF = (MembershipFunction *)(*_myMF).getMyTwin();
   myValues = new Vector(1);
   index = 0;
}// end of constructor

FuzzySet::FuzzySet(Vector invec )
{  myValues = new Vector(invec.size());
   (*myValues) = invec;
   index = invec.size();
}// end of constructor

FuzzySet::FuzzySet(Vector *invec, MembershipVector *_myMF)
{  myMF = (MembershipVector *)(*_myMF).getMyTwin();
   myValues = invec;
   index = (*invec).size();
}// end of constructor

FuzzySet::~FuzzySet()
{  //if(myMF) delete myMF;
   //if(myValues) delete myValues;
   cout << " Deallocate FuzzySet " << endl;
}// end of destructor

float FuzzySet::getMFValue(int a) { return (*myMF).getValue(a); }

float FuzzySet::getMFValue(float a) { return (*myMF).getValue(a); }

void FuzzySet::setMFunction(MembershipFunction *_newMF)
{  myMF = (MembershipVector *)(*_newMF).getMyTwin();
}// end of setMFunction()

FuzzySet * FuzzySet::cutOffCopy(float cut)
{  FuzzySet *ret = NULL;
   if(index)
   {  Vector a = *myValues;
      ret = new FuzzySet(a);
   }
   else   ret = new FuzzySet();

   MembershipFunction *f = (MembershipFunction *)(*myMF).getMyTwin();
   (*f).setCutOff(cut);
   (*ret).setMFunction(f);
   return ret;
}// end of cutOffCopy()

Function * FuzzySet::cutOffCopyMF(float cut)
{  MembershipFunction *ret = NULL;

   if(!index)
   {  ret = (MembershipFunction *)(*myMF).getMyTwin();
     (*ret).setCutOff(cut);
   }// end of if

   return ret;

}// end of cutOffCopy()

FuzzySet FuzzySet::operator=(const FuzzySet& RHS)
{  if(myMF) delete myMF;
   myMF = (MembershipVector *)(*RHS.myMF).getMyTwin();
   index = RHS.index;
   myValues = new Vector(1);
   if(index)
   { cout << *(RHS.myValues);
     (*myValues) = (*RHS.myValues);
   }
   return (*this);
}// end of operator=()

ostream& operator<<(ostream& os, const FuzzySet& RHS)
{ if(RHS.index)
  {  cout << " Vector is in use " << endl;
     cout << (*RHS.myValues) << endl;
  } 
  else 
    {  cout << " Function is in use "<< (*RHS.myMF) << endl;
    }
  return os;
}// end of operator<<
